
#ifndef __python_cnorxz_range_wrapper_h__
#define __python_cnorxz_range_wrapper_h__

#include <Python.h>
#include "cnorxz.h"

namespace CNORXZ
{
    class RangeWrapper
    {
    public:
	DEFAULT_MEMBERS(RangeWrapper);
	RangeWrapper(const RangePtr r) : mR(r) {}
	inline bool _init() const { return mR != nullptr; }
	inline SizeT size() const { return mR->size(); }
	inline SizeT dim() const { return mR->dim(); }
	inline RangePtr sub(SizeT pos) { return mR->sub(pos); }
	inline String stringMeta(SizeT pos) const { return mR->stringMeta(pos); }
	inline MArray<RangePtr> sub() const { return mR->sub(); }
	inline RangePtr sub(SizeT pos) const { return mR->sub(pos); }
	
    private:
	RangePtr mR;
    };
}

struct PyCxRange
{
    PyObject_HEAD
    CNORXZ::RangeWrapper* ptrObj;
};

int PyCxRange_init(PyCxRange* self, PyObject* args, PyObject* kwds);
void PyCxRange_dealloc(PyCxRange* self);
PyObject* PyCxRange_size(PyCxRange* self);
PyObject* PyCxRange_dim(PyCxRange* self);
PyObject* PyCxRange_sub(PyCxRange* self, PyObject* args, PyObject* kwds);
PyObject* PyCxRange_stringMeta(PyCxRange* self, PyObject* args, PyObject* kwds);
PyObject* PyCxRange_sub(PyCxRange* self, PyObject* args, PyObject* kwds);
PyTypeObject* PyCxRangeType_init();

extern PyMethodDef PyCxRange_methods[];
extern PyTypeObject PyCxRangeType;

#endif
